'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.just = just;
exports.maybe = maybe;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Just = function () {
  function Just(value) {
    _classCallCheck(this, Just);

    this.value = value;
  }

  _createClass(Just, [{
    key: 'filter',
    value: function filter(p) {
      if (p(this.value)) {
        return this;
      } else {
        return nothing;
      }
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      var result = f(this.value);
      return isNil(result) ? nothing : result;
    }
  }, {
    key: 'forEach',
    value: function forEach(f) {
      f(this.value);
    }
  }, {
    key: 'isJust',
    value: function isJust() {
      return true;
    }
  }, {
    key: 'isNothing',
    value: function isNothing() {
      return false;
    }
  }, {
    key: 'just',
    value: function just() {
      return this.value;
    }
  }, {
    key: 'map',
    value: function map(f) {
      return new Just(f(this.value));
    }
  }, {
    key: 'orElse',
    value: function orElse() {
      return this;
    }
  }, {
    key: 'orJust',
    value: function orJust() {
      return this.value;
    }
  }]);

  return Just;
}();

var Nothing = function () {
  function Nothing() {
    _classCallCheck(this, Nothing);
  }

  _createClass(Nothing, [{
    key: 'filter',
    value: function filter() {
      return this;
    }
  }, {
    key: 'flatMap',
    value: function flatMap() {
      return this;
    }
  }, {
    key: 'forEach',
    value: function forEach() {}
  }, {
    key: 'isJust',
    value: function isJust() {
      return false;
    }
  }, {
    key: 'isNothing',
    value: function isNothing() {
      return true;
    }
  }, {
    key: 'just',
    value: function just() {
      throw Error('Cannot call just() on a Nothing');
    }
  }, {
    key: 'map',
    value: function map() {
      return this;
    }
  }, {
    key: 'orElse',
    value: function orElse(m) {
      return m;
    }
  }, {
    key: 'orJust',
    value: function orJust(value) {
      return value;
    }
  }]);

  return Nothing;
}();

function isNil(value) {
  return value == null;
}

function just(value) {
  if (isNil(value)) {
    throw Error('Cannot create Just with an empty value: use flowtype!');
  }
  return new Just(value);
}

var nothing = exports.nothing = Object.freeze(new Nothing());

function maybe(value) {
  return isNil(value) ? nothing : new Just(value);
}